// generated by Fast Light User Interface Designer (fluid) version 1.0104

#include "fluidgui.h"
#include "vtkappList.h"
extern VTKAppList** aList;
static int NextWidth = 300;
static int NextHeight = 600;

Fl_Double_Window *MainControlWindow=(Fl_Double_Window *)0;

Fl_Button *NewAppBtn=(Fl_Button *)0;

Fl_Choice *MonthChoice=(Fl_Choice *)0;

Fl_Choice *DayChoice=(Fl_Choice *)0;

Fl_Choice *YearChoice=(Fl_Choice *)0;

Fl_Choice *VizChoice=(Fl_Choice *)0;

Fl_Value_Input *NextWidthInput=(Fl_Value_Input *)0;

Fl_Value_Input *NextHeightInput=(Fl_Value_Input *)0;

Fl_Check_Button *TimeLapseCheckBox=(Fl_Check_Button *)0;

Fl_Button *AnimationControl=(Fl_Button *)0;

Fl_Double_Window* make_main_window() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = MainControlWindow = new Fl_Double_Window(200, 500, "Main Control");
    w = o;
    o->box(FL_DOWN_BOX);
    o->color((Fl_Color)30);
    o->labelcolor((Fl_Color)17);
    o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    { Fl_Button* o = NewAppBtn = new Fl_Button(10, 380, 175, 40, "New Viz Window");
      o->box(FL_PLASTIC_THIN_UP_BOX);
      o->down_box(FL_PLASTIC_THIN_DOWN_BOX);
      o->callback((Fl_Callback*)LaunchVizWindowCb);
    }
    { Fl_Choice* o = MonthChoice = new Fl_Choice(10, 75, 175, 25, "Month");
      o->down_box(FL_BORDER_BOX);
      o->labelcolor((Fl_Color)17);
      o->callback((Fl_Callback*)UpdateDayListCb);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Choice* o = DayChoice = new Fl_Choice(10, 120, 175, 25, "Day");
      o->down_box(FL_BORDER_BOX);
      o->labelcolor((Fl_Color)17);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Choice* o = YearChoice = new Fl_Choice(10, 25, 175, 30, "Year");
      o->down_box(FL_BORDER_BOX);
      o->labelcolor((Fl_Color)17);
      o->callback((Fl_Callback*)UpdateDayListCb);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Choice* o = VizChoice = new Fl_Choice(10, 170, 175, 35, "Visualization");
      o->down_box(FL_BORDER_BOX);
      o->labelcolor((Fl_Color)17);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Value_Input* o = NextWidthInput = new Fl_Value_Input(10, 230, 175, 30, "Next Window Width");
      o->labelcolor((Fl_Color)17);
      o->minimum(1);
      o->maximum(1024);
      o->step(1);
      o->value(300);
      o->callback((Fl_Callback*)UpdateNextWidthCb);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Value_Input* o = NextHeightInput = new Fl_Value_Input(10, 290, 175, 30, "Next Window Height");
      o->labelcolor((Fl_Color)17);
      o->minimum(1);
      o->maximum(768);
      o->step(1);
      o->value(600);
      o->callback((Fl_Callback*)UpdateNextHeightCb);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Check_Button* o = TimeLapseCheckBox = new Fl_Check_Button(10, 340, 25, 25, "1 Week Time Lapse");
      o->down_box(FL_DOWN_BOX);
      o->labelcolor((Fl_Color)17);
    }
    { Fl_Button* o = AnimationControl = new Fl_Button(15, 430, 165, 50, "Pause/Play Animations");
      o->box(FL_PLASTIC_THIN_UP_BOX);
      o->down_box(FL_PLASTIC_THIN_DOWN_BOX);
      o->callback((Fl_Callback*)AnimationControlCb);
    }
    o->end();
  }
  MainControlWindow->position(0,0);
	MonthChoice->add("January");
	MonthChoice->add("Feburary");
	MonthChoice->add("March");
	MonthChoice->add("April");
	MonthChoice->add("May");
	MonthChoice->add("June");
	MonthChoice->add("July");
	MonthChoice->add("August");
	MonthChoice->add("September");
	MonthChoice->add("October");
	MonthChoice->add("November");
	MonthChoice->add("December");

	for(int i = 1; i < 31; i++)
	{
		DayChoice->add(intToChar(i));

	}

	for(int k = 1994; k < 2004; k++)
	{
		YearChoice->add(intToChar(k));
	}

	VizChoice->add("average wind speed");
	VizChoice->add("average wind direction");
    	VizChoice->add(	"average air temperature");
    	VizChoice->add(	"average 4\" soil temperature");
    	VizChoice->add(	"average humidity");
	VizChoice->add(	"total precipitation");
  return w;
}

void LaunchVizWindowCb(Fl_Button* btn, void* data) {
  cerr << "Launch App Callback" << endl;
	char buffer[128];
	buffer[0] = '\0';
	cerr << "Getting Month...";
	strcat(buffer, MonthChoice->text() );
	strcat(buffer,", ");
	cerr << "Day...";
	strcat(buffer, DayChoice->text() );
	strcat(buffer, " " );
	cerr << "Year...";
	strcat(buffer, YearChoice->text() );
	cerr << "Requesting Time Lapse" << endl;
	if( TimeLapseCheckBox->value())
		strcat(buffer," -- One Week Time Lapse");
	//Fl_Window* pWindow = NULL;
	//pWindow = new Fl_Window(0,0,NextWidth,NextHeight,buffer);
	VTKAppProperties* props = new VTKAppProperties();
	props->startx = 0;
	props->starty = 0;
	props->width = NextWidth;
	props->height = NextHeight;
	props->name = new char[strlen(buffer) + 1];
	strcpy( props->name, buffer );
	cerr << "Created App Properties Object at: " << props << endl;
	VTKApp** app = (*aList)->AddApp(props);
	if( app == NULL )
		return;
	//ThreadApp(app);
	cerr << "Waiting for App To Generate" << endl;
	while((*app) == NULL);
	cerr << "App Generated - Sending Messages" << endl;
	VTKAppMessage *pMsg;
	pMsg = new VTKAppMessage();

	if( TimeLapseCheckBox->value() )
	{
		pMsg->msg = VTKApp::VTKAPP_1WEEK_SET;
	}
	else
	{
		pMsg->msg = VTKApp::VTKAPP_SINGLEDAY_SET;
	}
	pMsg->msgData = NULL;
	//(*app)->Message(pMsg);
	(*aList)->RelayMessage(pMsg,app);

	InterestedDay* interest = new InterestedDay;
	interest->pWS = gWeatherService;
	interest->month = MonthChoice->value() + 1;
	interest->year = YearChoice->value() + 1994;
	interest->day = DayChoice->value() + 1;
	cerr << "DATE: " << MonthChoice->value() + 1 << ", " << DayChoice->value() + 1
		<< " " << YearChoice->value() + 1994 << endl
		<< "DATE: " << interest->month << ", " << interest->day << " " 
		<< interest->year << endl;
//	VizChoice->add("average wind speed");
//	VizChoice->add("average wind direction");
//    	VizChoice->add(	"average air temperature");
//    	VizChoice->add(	"average 4\" soil temperature");
//    	VizChoice->add(	"average humidity");
//	VizChoice->add(	"total precipitation");
	
	pMsg = new VTKAppMessage();
	pMsg->msg = VTKApp::VTKAPP_CREATE_IMAGEACTOR_SET;
	switch(VizChoice->value())
	{
	case 0:
		interest->attribute = AVG_WIND_SPEED;
		break;
	case 1:
		interest->attribute = AVG_WIND_DIRECTION;
		pMsg->msg = VTKApp::VTKAPP_CREATE_WINDDIR_GLYPHS_SET;
		break;
	case 2:
		interest->attribute = AVG_AIR_TEMP;
		break;
	case 3:
		interest->attribute = AVG_SOIL_TEMP;
		break;
	case 4:
		interest->attribute = AVG_HUMIDTY;
		break;
	case 5:
		interest->attribute = TOTAL_PRECIPITATION;
		break;
	}
	cerr << "Interesed Day " << interest->month << ", " << interest->day
		<< ' ' << interest->year << " Attribute: " << interest->attribute << endl;
	pMsg->msgData = (void*)interest;
	interest = NULL;
	
	//(*app)->Message(pMsg);
	(*aList)->RelayMessage( pMsg, app );

//	pMsg = new VTKAppMessage();
//	pMsg->msg = VTKApp::VTKAPP_RENDER;
	
//	(*app)->Message(pMsg);
	pMsg = NULL;
	cerr << "Callback Returning" << endl;
//	if( (*app)->HaveMessages() )
	//	(*app)->ProcessMessages();
}

void UpdateNextWidthCb(Fl_Value_Input* in,void* data) {
  NextWidth = (int)in->value();
}

void UpdateNextHeightCb(Fl_Value_Input* in,void* data) {
  NextHeight = (int)in->value();
}

char* intToChar(int num) {
  static int length;
	
	length = 0;
	
	if(num == 0)
		return "0";

	for(int temp = num; temp; temp /= 10)
		length++;
		
	char *text = new char[length + 1];
	
	text[length] = '\0';
	
	//printf("text: %s\n", text);
	
	for(int i = length - 1; i >= 0; i--, num /= 10)
		text[i] = num % 10 + 48;
	
	//printf("text: %s\n", text);
		
	return text;
}

void UpdateDayListCb(Fl_Choice* ch,void* data) {
  int month = MonthChoice->value() + 1;
	DayChoice->clear();
	int days = 31;
	switch(month)
	{
	case 2:
		if( (YearChoice->value() + 1991) % 4 == 0)
		{
			days = 29;
		}
		else
		{
			days = 28;
		}
		break;
	case 4:
	case 6:
	case 9:
	case 11:
		days = 30;
		break;
	default:
		//do nothing
		break;
	}

	for(int i = 0; i < days; i++)
	{
		DayChoice->add( intToChar( i + 1 ) );
	}

	DayChoice->value(0);
}

void AnimationControlCb(Fl_Button* btn, void* data) {
  //static clock_t lastToggle = 0;
	//if( clock() - lastToggle > 1000)
	//{
		(*aList)->TogglePauseAnimations();
	//	lastToggle = clock();
	//}
}
